/* Program 3.11 - List Insertion Sort */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

typedef struct node* link;
struct node { int item; link next; };

int main()
{
	int N, i;
	struct node heada, headb;
   link t, u, x, a, b;
   char buf[BUFSIZ];

   srand(time(NULL));	/* randomize numbers */

   printf("How many numbers? ");
   gets(buf);
   N = atoi(buf);

   a = &heada;	/* head of first list */

   /* generate list of 'N' random numbers */
   for (i = 0, t = a; i < N; i++)
   {
   	t->next = malloc(sizeof *t); /* create node */
      t = t->next; /* new node */
      t->item = rand() % 1000;
   }
   t->next = NULL; /* end of list */

   /* print input list */
   for (t=a->next; t!=NULL; t=t->next)
   {
   	printf("%d\n", t->item);
   }
   printf("Press ENTER to continue: ");
   gets(buf);

   /* now create new sorted list */
   b = &headb;
   b->next = NULL;

   /* loop thru old list and add each node to new list */
   for (t = a->next; t != NULL; t = u)
   {
   	u = t->next; /* next input node */
      for (x = b; x->next != NULL; x = x->next)
      { /* loop until insertion point or end of list */
      	if (x->next->item > t->item) break;
      }
      t->next = x->next;	/* new ent points to next node */
      x->next = t;	/* insert node into list */
	}

   /* print output list */
   for (t=b->next; t!=NULL; t=t->next)
   {
   	printf("%d\n", t->item);
   }
   printf("Press ENTER to terminate program: ");
   gets(buf);
}