/* program 5.10 - Inefficient Fibonacci numbers */
#include <stdio.h>
#include <stdlib.h>

int F(int i);
void print_line(int i);

int ncalls = 0;

int main()
{
	char buf[BUFSIZ];
   int num, x;

   printf("Don't pick a large number!\n");

   while (1)
   {
   	printf("Enter number or ENTER to quit: ");
      gets(buf);
      if (!*buf) break;
      num = atoi(buf);
      ncalls = 0;
      x = F(num);
      printf("F(%d) is %d, after %d calls\n", num, x, ncalls);
   }
   return 0;
}

int F(int i)
{
	print_line(i);

	if (i < 1) return 0;
   if (i == 1) return 1;
   return F(i-1) + F(i-2);
}

void print_line(int i)
{
	char buf[BUFSIZ];
   
	printf("%3d F(%d)\n", ++ncalls, i);
   if (ncalls % 24 == 23)
   {
   	printf("Press ENTER to continue: ");
      gets(buf);
   }
}

