/* prog 5.2 - questionable recursive algorithm */

#include <stdio.h>
#include <stdlib.h>

int puzzle(int n);
void print_line(char *s, int n);

static int ncalls=0;

int main()
{
	char buf[BUFSIZ];
   int n, m;

   do
   {
   	printf("Enter number: ");
      gets(buf);
      n = atoi(buf);
      ncalls = 0;	/* reset recursive call counter */
      m = puzzle(n);
      printf("Puzzle returned after %d calls\n", ncalls);
      printf("Continue? (y or n): ");
      gets(buf);
   } while (*buf != 'n');
   return 0;
}

int puzzle(int N)
{
	print_line("Entering puzzle", N);
	if (N <= 1) return 1; /* book has == */
   if (N % 2 == 0)
   {
   	return puzzle(N/2);
   }
   else
   {
   	return puzzle(3*N+1);
   }
}

void
print_line(char *s, int n)
{
   char buf[BUFSIZ];

	printf("%s, n=%d\n", s, n);
   if (++ncalls % 25 == 24)
   {
   	printf("Press ENTER to continue: ");
      gets(buf);
   }
}
