/* prog 5.3 - Euclid's Algorithm */
#include <stdio.h>
#include <stdlib.h>

int gcd(int m, int n);
void print_line(char *s, int m, int n);

static int ncalls=0;

int main()
{
	char buf[BUFSIZ];
   int n, m, g;

   do
   {
   	printf("Enter larger number: ");
      gets(buf);
      m = atoi(buf);
      printf("Enter smaller number: ");
      gets(buf);
      n = atoi(buf);
      ncalls = 0;	/* reset recursive call counter */
      g = gcd(m, n);
      printf("GCD returned %d after %d calls\n", g, ncalls);
		printf("Do it again? (y or n): ");
      gets(buf);
   } while (*buf != 'n');
   return 0;
}

int gcd(int m, int n)
{
	print_line("Entering GCD", m, n);
	if (n == 0) return m;
   return gcd(n, m % n);
}


void
print_line(char *s, int m, int n)
{
   char buf[BUFSIZ];

	printf("%s, m=%d, n=%d\n", s, m, n);
   if (++ncalls % 25 == 24)
   {
   	printf("Press ENTER to continue: ");
      gets(buf);
   }
}
