/* Prog 5.6 - Divid & Conquer to find Max */
#include <stdio.h>
#include <stdlib.h>

#define MAXENT 100 /* max number of entries */

typedef int Item;

void print_line(int a, int b);
Item max(Item tbl[], int a, int b);

int ncalls=0;

int main()
{
	char buf[BUFSIZ];
   int tbl[MAXENT], num, nent=0;

   while (1)
   {
   	printf("Enter a number, or ENTER to stop: ");
      gets(buf);
      if (buf[0] == '\0') break;
      tbl[nent++] = atoi(buf);
   }

   /* numbers entered ... find max */
   printf("%d numbers entered.  Searching for Max ...\n", nent);

   num = max(tbl,0,nent-1);
   printf("Max found was %d\n", num);

   printf("Press ENTER to terminate program: ");
   gets(buf);

   return 0;
}


Item max(Item a[], int l, int r)
{
	Item u, v;
   int m;

   print_line(l, r);	/* report progress */

   /* calculate midpoint */
   m = (l+r)/2;
   /* if only one entry, it must be the max */
   if (l == r) return a[l];

   /* get the max of the left and right half */
   u = max(a, l, m);
   v = max(a, m+1, r);

   /* now return the larger of the two */
   if (u > v) return u;
   else return v;
}

void print_line(int a, int b)
{
	char buf[BUFSIZ];
   
	printf("finding max between %d and %d\n", a, b);
   if (++ncalls % 25 == 24)
   {
   	printf("Press ENTER to continue: ");
      gets(buf);
   }
}

