/* prog 6.2 - selection sort */

#include <stdio.h>
#include <stdlib.h>

#include "sort.h"

int selection(Item a[], int l, int r)
{
	int i, j, ret=0, Min;

   /*
    * loop thru array
    * assume first entry is smallest
    * if smaller entry found, remember location
    * at end of loop, exchange first entry w/ smallest
    *
    * Continue thru array, each time swapping the
    * smallest remaining entry with the current one
    */
   for (i = l; i < r; i++)
   {	/* loop thru array */
   	Min = i;	/* assume this is the smallest */
      for (j = i+1; j <= r; j++)
   	{ /* loop thru rest of array looking for smallest */
      	if (less(a[j], a[Min])) Min = j; /* smaller - remember it */
      }
      ret++;	/* record number of swaps */
      /*
       * we could test to see if i & min are the same
       * if they were, we could skip the exchange
       */
      exch(a[i], a[Min]);	/* exchange smallest w/ current */
   }
   return ret;	/* return how many swaps */
}

#ifndef SORT
int sort(Item a[], int l, int r)
{
	return selection(a, l, r);
}
#endif

