/* prog 6.4 - bubble sort */

#include <stdio.h>
#include <stdlib.h>

#include "sort.h"

/*
 * Bubble Sort
 * This version can be made more efficient
 * If no swaps are performed during any one pass,
 * the sort can terminate since everything is sorted
 */
int bubble(Item a[], int l, int r)
{
	int i, j, ret=0;

   for (i = l; i < r; i++)
   { /* loop thru array */
   	for (j = r; j > i; j--)
      { /* loop thru rest of array */
      	ret++;	/* assume a swap */
         /* if out of order, swap */
      	compexch(a[j-1], a[j]);
      }
   }
   return ret;
}

#ifndef SORT
int sort(Item a[], int l, int r)
{
	return bubble(a, l, r);
}
#endif
