#include <stdio.h>
#define N 10000
main()
{
    /* id[] contains connection info, sz[] contains size of chain */
  int i, j, p, q, id[N], sz[N];
  
  /* initialize list by having each cell point to itself */
    for (i = 0; i < N; i++)
      {
      	id[i] = i; sz[i] = 1;
      }

    /* get pairs from stdin */
    while (scanf("%d %d\n", &p, &q) == 2)
      {
        /* find end of chain for both p & q */
        for (i = p; i != id[i]; i = id[i]) ; /* i is end of p chain */
        for (j = q; j != id[j]; j = id[j]) ; /* j is end of q chain */

        /* if same end point, they were already connected */
        if (i == j) continue;

        /* new connection - add smaller tree to larger one */
        if (sz[i] < sz[j])
        { /* i chain smaller than j - add i to j */
        	id[i] = j; sz[j] += sz[i]; /* i now points to j */
        }
        else
        {   /* j chain smaller than i - add j to i */
        	id[j] = i; sz[i] += sz[j]; /* j now points to i */
        }
        /* report new connection */
        printf(" %d %d\n", p, q);
      }
 }
