/* prog 3.8 Closest Point Computation */
/* must belinked with prog3.3.c */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#include "Point.h"

float randFloat(void);

main(int argc, char *argv[])
{
	float d;
   int i, j, cnt = 0, N;
   point *a;
   char buf[BUFSIZ];

   /* get number of points to generate */
   if (argc == 2)
   {
   	N = atoi(argv[1]);
      d = atof(argv[2]);
   }
   else
   {
   	printf("Enter # points: ");
      gets(buf);
      N = atoi(buf);
      printf("Enter distance: ");
      gets(buf);
      d = atof(buf);
   }

   printf("#points=%d, Distance=%f\n", N, d);

   /* allocate array to store points */
	a = (point *)malloc(N*(sizeof(*a)));

   /* generate N random points */
   for (i = 0; i < N; i++)
   {
   	a[i].x = randFloat();
      a[i].y = randFloat();
   }

   /* examine all point pairs to determine closest */
   for (i = 0; i < N; i++)
   { /* loop thru all points */
     for (j = i+1; j < N; j++)
     { /* loop thru all remaining points */
     	 /* if shorter than given distance, increment counter */
       if (distance(a[i], a[j]) < d) cnt++;
     } /* end inner loop */
   } /* end outer loop */

   /* report findings */
   printf("%d edges shorter than %f\n", cnt, d);
 }

float randFloat(void)
{
	return 1.0*rand()/RAND_MAX;
}
