/* prog 5.11 - Fibonacci - dynamic programming */

#include <stdio.h>
#include <stdlib.h>

#define MAXNUM 46

int F(int);
void print_line(int i);

int knownF[MAXNUM];
int unknown = 0;
int ncalls = 0;

int main()
{
	char buf[BUFSIZ];
   int num, ret;

   for (num=0; num < MAXNUM; num++) knownF[num] = unknown;

   while (1)
   {
   	printf("Enter number or ENTER to quit: ");
      gets(buf);
      if (*buf == '\0') break;
      num = atoi(buf);
      ncalls = 0;
      ret = F(num);
      printf("F(%d) is %d after %d calls\n",
      	num, ret, ncalls);
   }
   return 0;
}

int F(int i)
{
	int t;

   print_line(i);

   if (knownF[i] != unknown) return knownF[i];
   if (i == 0) t = 0;
   if (i == 1) t = 1;
   if (i > 1) t = F(i-1) + F(i-2);
   return knownF[i] = t;
}

void print_line(int i)
{
	char buf[BUFSIZ];
   
	printf("%3d F(%d)\n", ++ncalls, i);
   if (ncalls % 24 == 23)
   {
   	printf("Press ENTER to continue: ");
      gets(buf);
   }
}

