/* prog 5.20 - Construct a Parse Tree */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

char a[BUFSIZ]; int i;
typedef struct Tnode* link;
struct Tnode { char token; link l, r; };

link NEW(char token, link l, link r);
link parse(void);
void printnode(char c, int h);
void show(link x, int h);

int main()
{
	link ret;

   printf("Use one character variables or one digit numbers\n");
   
   while (1)
   {
   	printf("Enter expression or ENTER to quit: ");
      gets(a);
      if (*a == '\0') break;
      i = 0;	/* reset input pointer */
   	ret = parse();
      show(ret, 0);
   }
   return 0;
}

link NEW(char token, link l, link r)
{
	link x;

   x = (link)malloc(sizeof *x);
   x->token = token;
   x->l = l;
   x->r = r;

   return x;
}

link parse(void)
{
	char t;
   link x;

   while (isspace(a[i])) i++;

   printf("parse(%s)\n", a+i);
   
   t = a[i++];	/* found token */

   x = NEW(t, NULL, NULL);
   if ((t == '+') || (t == '*'))
   {
   	x->l = parse();
      x->r = parse();
   }

   return x;
}

/* following routines are from program 5.18 */
void printnode(char v, int h)
{
	int i;

   printf("[%2d] ", h);	/* print depth of tree */
   /* now print 2 spaces for each level above this node */
   for (i = 0; i < h; i++) printf("  ");
   /* finally, print this node */
   printf(" %c\n", v);
}

void show(link x, int h)
{
	/* print asterisk for empty nodes */
	if (x == NULL)
   {  /******* don't print anything
   	printnode(0, h); /* zero indicates empty (available) node */
      return;
   }

	/* now, display this node: right, node, left */
   show(x->r, h+1);			/* show the right subtree */
   printnode(x->token, h);	/* print this node */
   show(x->l, h+1);			/* print left subtree */
}

