/* sort.h - use with Sort Programs */

typedef int Item;

#define key(A) (A)
#define less(A, B) (key(A) < key(B))
#define exch(A, B) { Item t = A; A = B; B = t; }
#define compexch(A, B) if (less(B, A)) exch(A, B)

/*the following definitions can be changed by user */
#define MAXENT 1000	/* default max entries */
#define MAXNUM 100000	/* largest random number */

int sort(Item a[], int l, int r);


